﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Threading;

namespace BugSplat
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            startGameThread();
        }

        private void startGameThread()
        {
            Thread game = new Thread(gameLoop);
            game.IsBackground = true;
            game.Start();
        }

        private void gameLoop()
        {
            while (true)
            {
                Dispatcher.Invoke(new Action(() => updateGame()));
                Thread.Sleep(17);
            }
        }

        double bugY = 0;
        double bugYSpeed = 1;

        Random rand = new Random(1);

        private void updateGame()
        {
            Canvas.SetTop(bugImage, bugY);
            bugY = bugY + bugYSpeed;

            if (bugY > gameCanvas.Height)
            {
                int bugX = rand.Next(0, (int)gameCanvas.Width - (int)bugImage.Width);
                Canvas.SetLeft(bugImage, bugX );
                bugY = -bugImage.Height;
            }
        }
    }
}
